#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define node 28977  //節点数
#define nelm 57212  //要素数
#define iubc_max 690
#define iubc_u 690
#define iubc_v 690

#define UVP "NS_uvpRe01packSci1hei1.dat"
#define PHI "NS_phiRe01packSci1hei1.dat"

#define iend 10000
#define iout 50
#define dt 0.01
//#define re 10.0

#define ciubc_max 50 //Passive
#define iubc_c 50    //Passive
#define cc 1         //Passive

///境界条件
#define coef_phi 0.0                     /// 境界条件 左端 \phi
#define coef_phiBULK 0.0//(PHIint)       /// 初期条件 バルク全体 \phi 

double xx[2][node]; //節点座標
int nc[3][nelm]; //要素結合情報
int iubc[2]; //u,vの境界条件の節点総数
int nubc[2][iubc_max]; //u,vの境界条件を課す節点番号
double fubc[2][iubc_max]; //u,vの境界条件をの値


double uu[2][node]; double ua[2][node];
double bc[2][3][nelm]; double area[nelm]; double tau[nelm];
double ea[9][9][nelm]; double diag[node*3];double uvp[node*3];double bv[node*3];

double w01[node*3];double w02[node*3];double w03[node*3];
double w04[node*3];double w05[node*3];double w06[node*3];
double w07[node*3];double w08[node*3];double w09[node*3];
double w10[node*3];

int ni[3];

void stepch();
void bound0(double uvp[], int iubc[]);
void makeSF();
void maktau(double dti, double rei);
void makLHS(double dti, double rei, double ea[][9][nelm], double diag[]);
void makRHS(double dti, double rei, double uu[][node], double bv[]);
void dscale();
void GPBiCG(double A[][9][nelm],double x[], double b[], double d[], int ibc[],
	    double r[], double r0[], double p[], double t[], double y[], 
	    double u[], double z[], double w[], double Ap[], double At[], 
	    int k );
void matvec(double A[][9][nelm],double x[],double r[], int ibc[]);

////// for Passive scalar  /////////////////////////////////////////////////
int ciubc[cc]; //cの境界条件の節点総数
int cnubc[cc][iubc_max]; //cの境界条件を課す節点番号
double cfubc[cc][iubc_max]; //cの境界条件をの値

double ccu[cc][node]; double ccua[cc][node];
double cea[3][3][nelm]; double cdiag[node];double cuvp[node];double cbv[node];

double cw01[node];double cw02[node];double cw03[node];
double cw04[node];double cw05[node];double cw06[node];
double cw07[node];double cw08[node];double cw09[node];
double cw10[node];

void cstepch();
void cbound0(double cuvp[], int ciubc[]);
void cmaktau(double dti, double rei, double Sci);
void cmakLHS(double dti, double rei, double cea[][3][nelm], double cdiag[], double Sci);
void cmakRHS(double dti, double rei, double ccu[][node], double cbv[], double Sci);
void cdscale();
void cGPBiCG(double A[][3][nelm],double x[], double b[], double d[], int ibc[],
	    double r[], double r0[], double p[], double t[], double y[], 
	    double u[], double z[], double w[], double Ap[], double At[], 
	    int k );
void cmatvec(double A[][3][nelm],double x[],double r[], int ibc[]);
////////////////////////////////////////////////////////////


int main(void){

    char nod_f[100]; char tri_f[100];
    char bdu_f[100]; char bdv_f[100];
    double re;    
    char bdf_f[100];
    scanf("%s",nod_f);    scanf("%s",tri_f);
    scanf("%s",bdu_f);    scanf("%s",bdv_f);
    scanf("%lf",&re);     scanf("%s",bdf_f);

    FILE *gp;
    if((gp=fopen(nod_f,"r"))==NULL){printf("no 1\n"); exit(1);}

    FILE *hp;
    if((hp=fopen(tri_f,"r"))==NULL){printf("no 2\n"); exit(1);}

    FILE *ip;
    if((ip=fopen(bdu_f,"r"))==NULL){printf("no 3\n"); exit(1);}

    FILE *jp;
    if((jp=fopen(bdv_f,"r"))==NULL){printf("no 4\n"); exit(1);}

    FILE *jp2;///passive scalar
    if((jp2=fopen(bdf_f,"r"))==NULL){printf("no 5\n"); exit(1);}

    FILE *kaku2; 
    if((kaku2=fopen(UVP,"w"))==NULL){printf("no 6\n"); exit(1);}

    FILE *kaku3; 
    if((kaku3=fopen(PHI,"w"))==NULL){printf("no 8\n"); exit(1);}


////datain///////////////////////////////////////////
    int istep;
    double ttime;
    
    int i,kcg;
    int j,n;
    int ista; 
    double rei,dti,Sci;
    ista =-1; rei=1./re;  dti=1./dt;
    Sci=1.0;

    for(i=0;i<3;i++) ni[i]=node*i;

//入れ替え用の配列    
    double nod_sca[node][4];     int tri_sca[nelm][4]; 
    double bdu_sca[iubc_u][3];     double bdv_sca[iubc_v][3]; 
    double bdc_sca[iubc_c][3];    //passive sclar

    for(i=0;i<node;i++){
	fscanf(gp,"%lf",&nod_sca[i][0]);	
	fscanf(gp,"%lf",&nod_sca[i][1]);	
	fscanf(gp,"%lf",&nod_sca[i][2]);	
	fscanf(gp,"%lf",&nod_sca[i][3]);	
    }

    for(i=0;i<nelm;i++){
	for(j=0;j<4;j++){
	    fscanf(hp,"%d",&tri_sca[i][j]);	
	}
    }

    for(i=0;i<iubc_u;i++){
	fscanf(ip,"%lf",&bdu_sca[i][0]);	
	fscanf(ip,"%lf",&bdu_sca[i][1]);	
	fscanf(ip,"%lf",&bdu_sca[i][2]);	
    }

    for(i=0;i<iubc_v;i++){
	fscanf(jp,"%lf",&bdv_sca[i][0]);	
	fscanf(jp,"%lf",&bdv_sca[i][1]);	
	fscanf(jp,"%lf",&bdv_sca[i][2]);	
    }
    
    for(i=0;i<node;i++){
	xx[0][i] = nod_sca[i][1];	
	xx[1][i] = nod_sca[i][2];	
    }

    for(i=0;i<nelm;i++){
	nc[0][i] =tri_sca[i][1];	
	nc[1][i] =tri_sca[i][2];	
	nc[2][i] =tri_sca[i][3];		
    }

    for(i=0;i<iubc_max;i++){ 
	nubc[0][i]=0.0;	
	nubc[1][i]=0.0;	
    }
    for(i=0;i<iubc_u;i++) nubc[0][i]=bdu_sca[i][1];	
    for(i=0;i<iubc_v;i++) nubc[1][i]=bdv_sca[i][1];	
    

    for(i=0;i<iubc_max;i++){ 
	fubc[0][i]=0.0;	
	fubc[1][i]=0.0;	
    }
    for(i=0;i<iubc_u;i++) fubc[0][i]=bdu_sca[i][2];	
    for(i=0;i<iubc_v;i++) fubc[1][i]=bdv_sca[i][2];	
    
    iubc[0]=iubc_u;
    iubc[1]=iubc_v;

/////////////////passive sclar    
    for(i=0;i<iubc_c;i++){  
	fscanf(jp2,"%lf",&bdc_sca[i][0]);	
	fscanf(jp2,"%lf",&bdc_sca[i][1]);	
	fscanf(jp2,"%lf",&bdc_sca[i][2]);	
    }

    for(i=0;i<ciubc_max;i++) cnubc[0][i]=0;
    for(i=0;i<iubc_c;i++)    cnubc[0][i]=(int) bdc_sca[i][1];	
    
    for(i=0;i<ciubc_max;i++) cfubc[0][i]= 0.0;
    for(i=0;i<iubc_c;i++)    cfubc[0][i]= coef_phi * bdc_sca[i][2];	
    
    ciubc[0]=iubc_c;
//////////////////////end passive sclar


///// call initin////////////////////////////////////////
//initial condtition
    for(i=0;i<node*3;i++)uvp[i]=0.0;
    
// impose boundary condition
    for(i=0;i<2;i++){
	for(n=0;n<iubc[i];n++){
	    uvp[nubc[i][n]+ni[i]-1] = fubc[i][n];   //注意 
	}
    }

    for(i=0;i<2;i++){
	for(n=0;n<node;n++){
	    uu[i][n]=uvp[n+ni[i]];//注意
	    ua[i][n]=uvp[n+ni[i]];
	}
    }
//////////////////////////

//////////////////////////////////passive
// Initial boundary for passive sclar
    for(i=0;i<node;i++) cuvp[i]=0.0;

//// or ガウスパッケト
    
    int KK=70;
    int RRR=15;
    double dx= 0.3;
    double R[KK];
    double Ata[KK];
    double x0,y0;
    x0 = 40.;
    y0 = 80.;
    double aa =0.03;
    double hei =1.0; ///高さ
    for(i=0;i<KK;i++){
	R[i]=i*dx;
	Ata[i] = hei*exp(-aa*(R[i]*R[i]));
    }
    
    double rr2[node];
    for(i=0;i<node;i++){
	rr2[i] =(xx[0][i]-x0)*(xx[0][i]-x0)+ (xx[1][i]-y0)*(xx[1][i]-y0);
    }       
    
    for(i=0;i<node;i++){
	for(j=0;j<KK-1;j++){	    
	    if(rr2[i]<R[j+1]*R[j+1] && rr2[i]>R[j]*R[j]){
		cuvp[i] = coef_phiBULK + Ata[j];////かさ上げ＋高さ 		
	    }			    
	}
	if(rr2[i]>R[KK-1]*R[KK-1]){
	    cuvp[i] = coef_phiBULK ;////かさ上げ 		
	}
    }

//////////////エンドガウス

// Boundary condition for Passive scalar
    for(i=0;i<cc;i++){
	for(n=0;n<ciubc[i];n++){
	    cuvp[cnubc[i][n]-1] = cfubc[i][n];   //左端にphiの係数coef_phiをセット 
	}
    }
    
    for(i=0;i<cc;i++){
	for(n=0;n<node;n++){
	    ccu[i][n]=cuvp[n];
	    ccua[i][n]=cuvp[n];
	}
    }
//////////////////////////end of passive


    makeSF();

    for(istep=0;istep<iend;istep++){
	ttime=(double)(istep)*dt;

	maktau(dti,rei);
	makLHS(dti,rei,ea,diag);
	makRHS(dti,rei,uu,bv);
	GPBiCG(ea,uvp,bv,diag,iubc,w01,w02,w03,w04,w05,w06,w07,w08,w09,w10,kcg);
	stepch();

	if(istep/iout*iout==istep){
	    for(n=0;n<node;n++){
		//printf("%d %f %f %f %f %f \n", n+1, xx[0][n], xx[1][n], uvp[n+ni[0]], uvp[n+ni[1]], uvp[n+ni[2]]);
		fprintf(kaku2,"%d %lf %lf %lf %lf %lf \n", n+1, xx[0][n], xx[1][n],
			uvp[n+ni[0]], uvp[n+ni[1]], uvp[n+ni[2]]);
		fprintf(kaku3,"%d %f %f %f \n", n+1, xx[0][n], xx[1][n],cuvp[n]);
	    }
	    printf("NS =%d  \n", istep);
	}

        //// passive scalar
        cmaktau(dti,rei,Sci);
	cmakLHS(dti,rei,cea,cdiag,Sci);
	cmakRHS(dti,rei,ccu,cbv,Sci);
	cGPBiCG(cea,cuvp,cbv,cdiag,ciubc,cw01,cw02,cw03,cw04,cw05,cw06,cw07,cw08,cw09,cw10,kcg);
	cstepch();
        //// end of passive scalar
    }
    
    for(n=0;n<node;n++){
//	printf("%d %f %f %f %f %f \n", n+1, xx[0][n], xx[1][n],uvp[n+ni[0]], uvp[n+ni[1]], uvp[n+ni[2]]);
	fprintf(kaku2,"%d %lf %lf %lf %lf %lf \n", n+1, xx[0][n], xx[1][n],uvp[n+ni[0]], uvp[n+ni[1]], uvp[n+ni[2]]);
	fprintf(kaku3,"%d %f %f %f \n", n+1, xx[0][n], xx[1][n],cuvp[n]);
    }
    


    fclose(gp);
    fclose(hp);
    fclose(ip);
    fclose(jp);
    fclose(jp2);
    
    return 0;
}

void stepch(){
    int i,n;
    for(i=0;i<2;i++){
	for(n=0;n<node;n++){	
	    ua[i][n] = 1.5 * uvp[n+ni[i]] - 0.5*uu[i][n];
	    uu[i][n] = uvp[n+ni[i]];
	}
    }
}

void bound0(double uvp[], int iubc[]){
    int i,ib;
    for(i=0;i<2;i++){
	for(ib=0;ib<iubc[i];ib++){
	    uvp[nubc[i][ib]+ni[i]-1]=0.0;
	}
    }
}

void makeSF(){
    int m,n1,n2,n3;
    double x1,x2,x3,y1,y2,y3,a02;
    int i=0;
    for(m=0;m<nelm;m++){
	n1 = nc[1-1][m];
	n2 = nc[2-1][m];
	n3 = nc[3-1][m];
	x1 = xx[1-1][n1-1];
	x2 = xx[1-1][n2-1];
	x3 = xx[1-1][n3-1];
	y1 = xx[2-1][n1-1];
	y2 = xx[2-1][n2-1];
	y3 = xx[2-1][n3-1];
	a02 = x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2);
	if ( a02 <= 0.0 ) {printf("Area Failure %d %f %f %f\n", i,a02,x2,x3);i++;}
	
	area[m] = a02 * 0.5;
	a02 = 1.0 / a02;
	
	bc[0][0][m] = (y2 - y3) * a02;
	bc[0][1][m] = (y3 - y1) * a02;
	bc[0][2][m] = (y1 - y2) * a02;
	bc[1][0][m] = (x3 - x2) * a02;
	bc[1][1][m] = (x1 - x3) * a02;
	bc[1][2][m] = (x2 - x1) * a02;
    }
}

void maktau(double dti, double rei){
    int m, n1, n2, n3;
    double a01, b1, b2, b3, c1, c2, c3, u, v, uv, d, t1, t2, t3;
    
    t1 = 4.0 * dti * dti;
    
    for(m=0;m<nelm;m++){
	n1 = nc[0][m];
	n2 = nc[1][m];
	n3 = nc[2][m];
	a01 = area[m];
	b1 = bc[0][0][m];
	b2 = bc[0][1][m];
	b3 = bc[0][2][m];
	c1 = bc[1][0][m];
	c2 = bc[1][1][m];
	c3 = bc[1][2][m];
	u = ( ua[0][n1-1] + ua[0][n2-1] + ua[0][n3-1] ) / 3.0;
	v = ( ua[1][n1-1] + ua[1][n2-1] + ua[1][n3-1] ) / 3.0;
	uv = u * u + v * v;
	d = fabs( u * b1 + v * c1 )  + fabs( u * b2 + v * c2 ) 
	    + fabs( u * b3 + v * c3 );
	
	t2 = d * d;
	if(uv<0.0000000001){
	    t3 = (2.0 * rei / a01)*(2.0 * rei / a01);
	} else{
	    t3 = (rei * d * d / uv)*(rei * d * d / uv);
	}
	tau[m] = 1.0 / sqrt(t1 + t2 + t3);   
    }   
}

////////////////////////////////////////////////////////////////
////makLHS
///////////////////////////////////////////////////////////////
void makLHS(double dti, double rei, double ea[][9][nelm], double diag[]){
    int i;
    int  m, n1, n2, n3;
    double a01, a03, b1, b2, b3, c1, c2, c3,              
	ts,      tp,      ua1,     ua2,     ua3,     
	va1,     va2,     va3,             
	emd,     emu,     emu1,    emu2,    emu3,    
	emv1,    emv2,    emv3,            
	eMs_11,  eMs_12,  eMs_13,  eMs_21,  eMs_22,
	eMs_23,  eMs_31,  eMs_32,  eMs_33, 
	eMp1_1,  eMp1_2,  eMp1_3,  eMp2_1,  eMp2_2,  eMp2_3,
	
	eA_11,   eA_12,   eA_13,   eA_21,   eA_22,   eA_23,   
	eA_31,   eA_32,   eA_33,  
	easu1,   easu2,   easu3,   easv1,   easv2,   easv3,
	
	eAs_11,  eAs_12,  eAs_13,  eAs_21,  eAs_22,  eAs_23,  
	eAs_31,  eAs_32,  eAs_33, 
	eAp1_11, eAp1_12, eAp1_13, eAp1_21, eAp1_22, eAp1_23, 
	eAp1_31, eAp1_32, eAp1_33,
	eAp2_11, eAp2_12, eAp2_13, eAp2_21, eAp2_22, eAp2_23, 
	eAp2_31, eAp2_32, eAp2_33,
	eD11_11, eD11_12, eD11_13, eD11_22, eD11_23, eD11_33,
	
	eD12_11, eD12_12, eD12_13, eD12_21, eD12_22, eD12_23, 
	eD12_31, eD12_32, eD12_33,
	eD22_11, eD22_12, eD22_13, eD22_22, eD22_23, eD22_33,
	
	eG1_1,   eG1_2,   eG1_3,   eG2_1,   eG2_2,   eG2_3,
                             
	tua,     tva,     at1,     at2,     at3, 
        
	eGs1_11, eGs1_12, eGs1_13, eGs1_21, eGs1_22, eGs1_23, 
	eGs1_31, eGs1_32, eGs1_33,
	eGs2_11, eGs2_12, eGs2_13, eGs2_21, eGs2_22, eGs2_23, 
	eGs2_31, eGs2_32, eGs2_33,
	eGp_11,  eGp_12,  eGp_13,  eGp_22,  eGp_23,  eGp_33;
    
    for(i=0;i<node*3;i++){
	diag[i] = 0.0;
    }
    
    for(m=0;m<nelm;m++){
	n1 = nc[0][m];
	n2 = nc[1][m];
	n3 = nc[2][m];
	a01 = area[m];
	a03 = area[m] / 3.0;
	ts = tau[m];
	tp = tau[m];
	b1 = bc[0][0][m];
	b2 = bc[0][1][m];
	b3 = bc[0][2][m];
	c1 = bc[1][0][m];
	c2 = bc[1][1][m];
	c3 = bc[1][2][m];
	ua1 = ua[0][n1-1];
	ua2 = ua[0][n2-1];
	ua3 = ua[0][n3-1];
	va1 = ua[1][n1-1];
	va2 = ua[1][n2-1];
	va3 = ua[1][n3-1];
	
// ---- M Matrix ----------
         emd = a03 * 0.5;
         emu = a03 * 0.25;
	 
// ---- Ms Matrix ----------
         emu1 = emd * ua1 + emu * ua2 + emu * ua3;
         emu2 = emu * ua1 + emd * ua2 + emu * ua3;
         emu3 = emu * ua1 + emu * ua2 + emd * ua3;
         emv1 = emd * va1 + emu * va2 + emu * va3;
         emv2 = emu * va1 + emd * va2 + emu * va3;
         emv3 = emu * va1 + emu * va2 + emd * va3;
         eMs_11 = ts * (b1 * emu1 + c1 * emv1);
         eMs_12 = ts * (b1 * emu2 + c1 * emv2);
         eMs_13 = ts * (b1 * emu3 + c1 * emv3);
         eMs_21 = ts * (b2 * emu1 + c2 * emv1);
         eMs_22 = ts * (b2 * emu2 + c2 * emv2);
         eMs_23 = ts * (b2 * emu3 + c2 * emv3);
         eMs_31 = ts * (b3 * emu1 + c3 * emv1);
         eMs_32 = ts * (b3 * emu2 + c3 * emv2);
         eMs_33 = ts * (b3 * emu3 + c3 * emv3);
	 
// ---- Mp Matrix ----------
         eMp1_1 = tp * b1 * a03;
         eMp1_2 = tp * b2 * a03;
         eMp1_3 = tp * b3 * a03;
         eMp2_1 = tp * c1 * a03;
         eMp2_2 = tp * c2 * a03;
         eMp2_3 = tp * c3 * a03;
	 
// ---- A Matrix ----------
         eA_11 = emu1 * b1 + emv1 * c1;
         eA_12 = emu1 * b2 + emv1 * c2;
         eA_13 = emu1 * b3 + emv1 * c3;
         eA_21 = emu2 * b1 + emv2 * c1;
         eA_22 = emu2 * b2 + emv2 * c2;
         eA_23 = emu2 * b3 + emv2 * c3;
         eA_31 = emu3 * b1 + emv3 * c1;
         eA_32 = emu3 * b2 + emv3 * c2;
         eA_33 = emu3 * b3 + emv3 * c3;
	 
// ---- As Matrix ----------
         easu1 = eMs_11 * ua1 + eMs_12 * ua2 + eMs_13 * ua3;
         easu2 = eMs_21 * ua1 + eMs_22 * ua2 + eMs_23 * ua3;
         easu3 = eMs_31 * ua1 + eMs_32 * ua2 + eMs_33 * ua3;
         easv1 = eMs_11 * va1 + eMs_12 * va2 + eMs_13 * va3;
         easv2 = eMs_21 * va1 + eMs_22 * va2 + eMs_23 * va3;
         easv3 = eMs_31 * va1 + eMs_32 * va2 + eMs_33 * va3;
	 
         eAs_11 = easu1 * b1 + easv1 * c1;
         eAs_12 = easu1 * b2 + easv1 * c2;
         eAs_13 = easu1 * b3 + easv1 * c3;
         eAs_21 = easu2 * b1 + easv2 * c1;
         eAs_22 = easu2 * b2 + easv2 * c2;
         eAs_23 = easu2 * b3 + easv2 * c3;
         eAs_31 = easu3 * b1 + easv3 * c1;
         eAs_32 = easu3 * b2 + easv3 * c2;
         eAs_33 = easu3 * b3 + easv3 * c3;
	 
// ---- Ap Matrix ----------
         tua = tp * (ua1 + ua2 + ua3) * a03;
         tva = tp * (va1 + va2 + va3) * a03;
	 
         eAp1_11 = tua * b1 * b1 + tva * b1 * c1;
         eAp1_12 = tua * b1 * b2 + tva * b1 * c2;
         eAp1_13 = tua * b1 * b3 + tva * b1 * c3;
         eAp1_21 = tua * b2 * b1 + tva * b2 * c1;
         eAp1_22 = tua * b2 * b2 + tva * b2 * c2;
         eAp1_23 = tua * b2 * b3 + tva * b2 * c3;
         eAp1_31 = tua * b3 * b1 + tva * b3 * c1;
         eAp1_32 = tua * b3 * b2 + tva * b3 * c2;
         eAp1_33 = tua * b3 * b3 + tva * b3 * c3;
         eAp2_11 = tua * c1 * b1 + tva * c1 * c1;
         eAp2_12 = tua * c1 * b2 + tva * c1 * c2;
         eAp2_13 = tua * c1 * b3 + tva * c1 * c3;
         eAp2_21 = tua * c2 * b1 + tva * c2 * c1;
         eAp2_22 = tua * c2 * b2 + tva * c2 * c2;
         eAp2_23 = tua * c2 * b3 + tva * c2 * c3;
         eAp2_31 = tua * c3 * b1 + tva * c3 * c1;
         eAp2_32 = tua * c3 * b2 + tva * c3 * c2;
         eAp2_33 = tua * c3 * b3 + tva * c3 * c3;
	 
// ---- D Matrix ----------
         eD11_11 = a01 * rei * (b1 * b1 + b1 * b1 + c1 * c1);
         eD11_12 = a01 * rei * (b1 * b2 + b1 * b2 + c1 * c2);
         eD11_13 = a01 * rei * (b1 * b3 + b1 * b3 + c1 * c3);
         eD11_22 = a01 * rei * (b2 * b2 + b2 * b2 + c2 * c2);
         eD11_23 = a01 * rei * (b2 * b3 + b2 * b3 + c2 * c3);
         eD11_33 = a01 * rei * (b3 * b3 + b3 * b3 + c3 * c3);

         eD22_11 = a01 * rei * (c1 * c1 + c1 * c1 + b1 * b1);
         eD22_12 = a01 * rei * (c1 * c2 + c1 * c2 + b1 * b2);
         eD22_13 = a01 * rei * (c1 * c3 + c1 * c3 + b1 * b3);
         eD22_22 = a01 * rei * (c2 * c2 + c2 * c2 + b2 * b2);
         eD22_23 = a01 * rei * (c2 * c3 + c2 * c3 + b2 * b3);
         eD22_33 = a01 * rei * (c3 * c3 + c3 * c3 + b3 * b3);
	 
         eD12_11 = a01 * rei * c1 * b1;
         eD12_12 = a01 * rei * c1 * b2;
         eD12_13 = a01 * rei * c1 * b3;
         eD12_21 = a01 * rei * c2 * b1;
         eD12_22 = a01 * rei * c2 * b2;
         eD12_23 = a01 * rei * c2 * b3;
         eD12_31 = a01 * rei * c3 * b1;
	 eD12_32 = a01 * rei * c3 * b2;
         eD12_33 = a01 * rei * c3 * b3;
	 
// ---- G & C Matrix ----------
         eG1_1 = b1 * a03;
         eG1_2 = b2 * a03;
         eG1_3 = b3 * a03;
         eG2_1 = c1 * a03;
         eG2_2 = c2 * a03;
         eG2_3 = c3 * a03;

// ---- Gs Matrix ----------
         tua = ts * (ua1 + ua2 + ua3) * a03;
         tva = ts * (va1 + va2 + va3) * a03;
	 
         at1 = tua * b1 + tva * c1;
         at2 = tua * b2 + tva * c2;
         at3 = tua * b3 + tva * c3;
	 
         eGs1_11 = at1 * b1;
         eGs1_12 = at1 * b2;
         eGs1_13 = at1 * b3;
         eGs1_21 = at2 * b1;
         eGs1_22 = at2 * b2;
         eGs1_23 = at2 * b3;
         eGs1_31 = at3 * b1;
         eGs1_32 = at3 * b2;
         eGs1_33 = at3 * b3;

         eGs2_11 = at1 * c1;
         eGs2_12 = at1 * c2;
         eGs2_13 = at1 * c3;
         eGs2_21 = at2 * c1;
	 eGs2_22 = at2 * c2;
         eGs2_23 = at2 * c3;
         eGs2_31 = at3 * c1;
         eGs2_32 = at3 * c2;
         eGs2_33 = at3 * c3;
	 
// ---- Gp Matrix ----------
         eGp_11 = tp * (b1 * b1 + c1 * c1) * a01;
         eGp_12 = tp * (b1 * b2 + c1 * c2) * a01;
         eGp_13 = tp * (b1 * b3 + c1 * c3) * a01;
         eGp_22 = tp * (b2 * b2 + c2 * c2) * a01;
         eGp_23 = tp * (b2 * b3 + c2 * c3) * a01;
         eGp_33 = tp * (b3 * b3 + c3 * c3) * a01;
	 
// ---------- Element by Element ( 9 x 9 ) ----------
//  Momentum X A(1-3,1-9)
	 
	 ea[1-1][1-1][m] = dti * (emd + eMs_11)  +  0.5 * (eA_11 + eAs_11 + eD11_11);
	 ea[1-1][2-1][m] = dti * (emu + eMs_12)  +  0.5 * (eA_12 + eAs_12 + eD11_12);
	 ea[1-1][3-1][m] = dti * (emu + eMs_13)  +  0.5 * (eA_13 + eAs_13 + eD11_13);
	 ea[2-1][1-1][m] = dti * (emu + eMs_21)  +  0.5 * (eA_21 + eAs_21 + eD11_12);
	 ea[2-1][2-1][m] = dti * (emd + eMs_22)  +  0.5 * (eA_22 + eAs_22 + eD11_22);
	 ea[2-1][3-1][m] = dti * (emu + eMs_23)  +  0.5 * (eA_23 + eAs_23 + eD11_23);
	 ea[3-1][1-1][m] = dti * (emu + eMs_31)  +  0.5 * (eA_31 + eAs_31 + eD11_13);
	 ea[3-1][2-1][m] = dti * (emu + eMs_32)  +  0.5 * (eA_32 + eAs_32 + eD11_23);
	 ea[3-1][3-1][m] = dti * (emd + eMs_33)  +  0.5 * (eA_33 + eAs_33 + eD11_33);
	 ea[1-1][4-1][m] = 0.5 * eD12_11;
	 ea[1-1][5-1][m] = 0.5 * eD12_12;
	 ea[1-1][6-1][m] = 0.5 * eD12_13;
	 ea[2-1][4-1][m] = 0.5 * eD12_21;
	 ea[2-1][5-1][m] = 0.5 * eD12_22;
	 ea[2-1][6-1][m] = 0.5 * eD12_23;
	 ea[3-1][4-1][m] = 0.5 * eD12_31;
	 ea[3-1][5-1][m] = 0.5 * eD12_32;
	 ea[3-1][6-1][m] = 0.5 * eD12_33;
	 ea[1-1][7-1][m] = - eG1_1 + eGs1_11;
	 ea[1-1][8-1][m] = - eG1_1 + eGs1_12;
	 ea[1-1][9-1][m] = - eG1_1 + eGs1_13;
	 ea[2-1][7-1][m] = - eG1_2 + eGs1_21;
	 ea[2-1][8-1][m] = - eG1_2 + eGs1_22;
	 ea[2-1][9-1][m] = - eG1_2 + eGs1_23;
	 ea[3-1][7-1][m] = - eG1_3 + eGs1_31;
	 ea[3-1][8-1][m] = - eG1_3 + eGs1_32;
	 ea[3-1][9-1][m] = - eG1_3 + eGs1_33;

// Momentum Y A[4-6][1-9]

	 ea[ 4-1][ 1-1][ m] = 0.5 * eD12_11;
	 ea[ 4-1][ 2-1][ m] = 0.5 * eD12_21;
	 ea[ 4-1][ 3-1][ m] = 0.5 * eD12_31;
	 ea[ 5-1][ 1-1][ m] = 0.5 * eD12_12;
	 ea[ 5-1][ 2-1][ m] = 0.5 * eD12_22;
	 ea[ 5-1][ 3-1][ m] = 0.5 * eD12_32;
	 ea[ 6-1][ 1-1][ m] = 0.5 * eD12_13;
	 ea[ 6-1][ 2-1][ m] = 0.5 * eD12_23;
	 ea[ 6-1][ 3-1][ m] = 0.5 * eD12_33;
	 ea[ 4-1][ 4-1][ m] = dti * (emd + eMs_11)  +  0.5 * (eA_11 + eAs_11 + eD22_11);
	 ea[ 4-1][ 5-1][ m] = dti * (emu + eMs_12)  +  0.5 * (eA_12 + eAs_12 + eD22_12);
	 ea[ 4-1][ 6-1][ m] = dti * (emu + eMs_13)  +  0.5 * (eA_13 + eAs_13 + eD22_13);
	 ea[ 5-1][ 4-1][ m] = dti * (emu + eMs_21)  +  0.5 * (eA_21 + eAs_21 + eD22_12);
	 ea[ 5-1][ 5-1][ m] = dti * (emd + eMs_22)  +  0.5 * (eA_22 + eAs_22 + eD22_22);
	 ea[ 5-1][ 6-1][ m] = dti * (emu + eMs_23)  +  0.5 * (eA_23 + eAs_23 + eD22_23);
	 ea[ 6-1][ 4-1][ m] = dti * (emu + eMs_31)  +  0.5 * (eA_31 + eAs_31 + eD22_13);
	 ea[ 6-1][ 5-1][ m] = dti * (emu + eMs_32)  +  0.5 * (eA_32 + eAs_32 + eD22_23);
	 ea[ 6-1][ 6-1][ m] = dti * (emd + eMs_33)  +  0.5 * (eA_33 + eAs_33 + eD22_33);
	 ea[ 4-1][ 7-1][ m] = - eG2_1 + eGs2_11;
	 ea[ 4-1][ 8-1][ m] = - eG2_1 + eGs2_12;
	 ea[ 4-1][ 9-1][ m] = - eG2_1 + eGs2_13;
	 ea[ 5-1][ 7-1][ m] = - eG2_2 + eGs2_21;
	 ea[ 5-1][ 8-1][ m] = - eG2_2 + eGs2_22;
	 ea[ 5-1][ 9-1][ m] = - eG2_2 + eGs2_23;
	 ea[ 6-1][ 7-1][ m] = - eG2_3 + eGs2_31;
	 ea[ 6-1][ 8-1][ m] = - eG2_3 + eGs2_32;
	 ea[ 6-1][ 9-1][ m] = - eG2_3 + eGs2_33;

//! Continuity A[7-9][1-9]

	 ea[ 7-1][ 1-1][ m] = eG1_1 + dti * eMp1_1 + 0.5 * eAp1_11;
	 ea[ 7-1][ 2-1][ m] = eG1_2 + dti * eMp1_1 + 0.5 * eAp1_12;
	 ea[ 7-1][ 3-1][ m] = eG1_3 + dti * eMp1_1 + 0.5 * eAp1_13;
	 ea[ 8-1][ 1-1][ m] = eG1_1 + dti * eMp1_2 + 0.5 * eAp1_21;
	 ea[ 8-1][ 2-1][ m] = eG1_2 + dti * eMp1_2 + 0.5 * eAp1_22;
	 ea[ 8-1][ 3-1][ m] = eG1_3 + dti * eMp1_2 + 0.5 * eAp1_23;
	 ea[ 9-1][ 1-1][ m] = eG1_1 + dti * eMp1_3 + 0.5 * eAp1_31;
	 ea[ 9-1][ 2-1][ m] = eG1_2 + dti * eMp1_3 + 0.5 * eAp1_32;
	 ea[ 9-1][ 3-1][ m] = eG1_3 + dti * eMp1_3 + 0.5 * eAp1_33;
	 ea[ 7-1][ 4-1][ m] = eG2_1 + dti * eMp2_1 + 0.5 * eAp2_11;
	 ea[ 7-1][ 5-1][ m] = eG2_2 + dti * eMp2_1 + 0.5 * eAp2_12;
	 ea[ 7-1][ 6-1][ m] = eG2_3 + dti * eMp2_1 + 0.5 * eAp2_13;
	 ea[ 8-1][ 4-1][ m] = eG2_1 + dti * eMp2_2 + 0.5 * eAp2_21;
	 ea[ 8-1][ 5-1][ m] = eG2_2 + dti * eMp2_2 + 0.5 * eAp2_22;
	 ea[ 8-1][ 6-1][ m] = eG2_3 + dti * eMp2_2 + 0.5 * eAp2_23;
	 ea[ 9-1][ 4-1][ m] = eG2_1 + dti * eMp2_3 + 0.5 * eAp2_31;
	 ea[ 9-1][ 5-1][ m] = eG2_2 + dti * eMp2_3 + 0.5 * eAp2_32;
	 ea[ 9-1][ 6-1][ m] = eG2_3 + dti * eMp2_3 + 0.5 * eAp2_33;
	 ea[ 7-1][ 7-1][ m] = eGp_11;
	 ea[ 7-1][ 8-1][ m] = eGp_12;
	 ea[ 7-1][ 9-1][ m] = eGp_13;
	 ea[ 8-1][ 7-1][ m] = eGp_12;
	 ea[ 8-1][ 8-1][ m] = eGp_22;
	 ea[ 8-1][ 9-1][ m] = eGp_23;
	 ea[ 9-1][ 7-1][ m] = eGp_13;
	 ea[ 9-1][ 8-1][ m] = eGp_23;
	 ea[ 9-1][ 9-1][ m] = eGp_33;


	 
//! ---------- for Scaling ----------
	 diag[n1+ni[0]-1] = diag[n1+ni[0]-1] + ea[ 1-1][ 1-1][ m];
	 diag[n2+ni[0]-1] = diag[n2+ni[0]-1] + ea[ 2-1][ 2-1][ m];
	 diag[n3+ni[0]-1] = diag[n3+ni[0]-1] + ea[ 3-1][ 3-1][ m];
	 diag[n1+ni[1]-1] = diag[n1+ni[1]-1] + ea[ 4-1][ 4-1][ m];
	 diag[n2+ni[1]-1] = diag[n2+ni[1]-1] + ea[ 5-1][ 5-1][ m];
	 diag[n3+ni[1]-1] = diag[n3+ni[1]-1] + ea[ 6-1][ 6-1][ m];
	 diag[n1+ni[2]-1] = diag[n1+ni[2]-1] + ea[ 7-1][ 7-1][ m];
	 diag[n2+ni[2]-1] = diag[n2+ni[2]-1] + ea[ 8-1][ 8-1][ m];
	 diag[n3+ni[2]-1] = diag[n3+ni[2]-1] + ea[ 9-1][ 9-1][ m];
    }

  
//! Diagonal Scaling      
    dscale ();
}
/////////////////////////////////////////////////////
//////makRHS
////////////////////////////////////////////////////
void makRHS(double dti, double rei, double uu[][node], double bv[]){
    int i;    
    int m, n1, n2, n3;
    double  a01, a03, b1, b2, b3, c1, c2, c3, ts, tp,     
	ua1, ua2, ua3, va1, va2, va3, u1, u2, u3, v1, v2, v3,          
	emd, emu, emua1, emua2, emua3, emva1, emva2, emva3,            
	dxu, dyu, dxv, dyv, sxx, sxy, syy, tumu, tvmu, tumv, tvmv,     
	tu, tv, atu, atv, stxu, stxv, styu, styv,                      
	eMu1,  eMu2,  eMu3,  eMv1,  eMv2,  eMv3,                       
	eAu1,  eAu2,  eAu3,  eAv1,  eAv2,  eAv3,                       
	eDu1,  eDu2,  eDu3,  eDv1,  eDv2,  eDv3,                       
	eMsu1, eMsu2, eMsu3, eMsv1, eMsv2, eMsv3,                      
	eAsu1, eAsu2, eAsu3, eAsv1, eAsv2, eAsv3,                      
	eMp1,  eMp2,  eMp3,  eAp1,  eAp2,  eAp3;
    
    for(i=0;i<node*3;i++){
	bv[i] = 0.0;
    }
    
    for(m=0;m<nelm;m++){
	n1 = nc[1-1][m];
	n2 = nc[2-1][m];
	n3 = nc[3-1][m];
	a01 = area[m];
	a03 = a01 / 3.0;
	emd = a03 * 0.5;
	emu = a03 * 0.25;
	b1 = bc[1-1][1-1][m];
	b2 = bc[1-1][2-1][m];
	b3 = bc[1-1][3-1][m];
	c1 = bc[2-1][1-1][m];
	c2 = bc[2-1][2-1][m];
	c3 = bc[2-1][3-1][m];
    
	u1  = uu[1-1][n1-1];
	u2  = uu[1-1][n2-1];
	u3  = uu[1-1][n3-1];
	v1  = uu[2-1][n1-1];
	v2  = uu[2-1][n2-1];
	v3  = uu[2-1][n3-1];
	ua1 = ua[1-1][n1-1];
	ua2 = ua[1-1][n2-1];
	ua3 = ua[1-1][n3-1];
	va1 = ua[2-1][n1-1];
	va2 = ua[2-1][n2-1];
	va3 = ua[2-1][n3-1];
	
	dxu = b1 * u1 + b2 * u2 + b3 * u3;
	dyu = c1 * u1 + c2 * u2 + c3 * u3;
	dxv = b1 * v1 + b2 * v2 + b3 * v3;
	dyv = c1 * v1 + c2 * v2 + c3 * v3;
	
//! ---------- Galerkin term ----------
// M Term
	eMu1 = emd * u1 + emu * u2 + emu * u3;
	eMu2 = emu * u1 + emd * u2 + emu * u3;
	eMu3 = emu * u1 + emu * u2 + emd * u3;
	eMv1 = emd * v1 + emu * v2 + emu * v3;
	eMv2 = emu * v1 + emd * v2 + emu * v3;
	eMv3 = emu * v1 + emu * v2 + emd * v3;
	
// A Term
	emua1 = emd * ua1 + emu * ua2 + emu * ua3;
	emua2 = emu * ua1 + emd * ua2 + emu * ua3;
	emua3 = emu * ua1 + emu * ua2 + emd * ua3;
	emva1 = emd * va1 + emu * va2 + emu * va3;
	emva2 = emu * va1 + emd * va2 + emu * va3;
	emva3 = emu * va1 + emu * va2 + emd * va3;
	eAu1  = emua1 * dxu + emva1 * dyu;
	eAu2  = emua2 * dxu + emva2 * dyu;
	eAu3  = emua3 * dxu + emva3 * dyu;
	eAv1  = emua1 * dxv + emva1 * dyv;
	eAv2  = emua2 * dxv + emva2 * dyv;
	eAv3  = emua3 * dxv + emva3 * dyv;
	
//! D Term
	sxx  = rei * (dxu + dxu) * a01;
	sxy  = rei * (dyu + dxv) * a01;
	syy  = rei * (dyv + dyv) * a01;
	eDu1 = b1 * sxx + c1 * sxy;
	eDu2 = b2 * sxx + c2 * sxy;
	eDu3 = b3 * sxx + c3 * sxy;
	eDv1 = b1 * sxy + c1 * syy;
	eDv2 = b2 * sxy + c2 * syy;
	eDv3 = b3 * sxy + c3 * syy;
	
	bv[n1+ni[0]-1] = bv[n1+ni[0]-1] + eMu1 * dti  -  0.5 * (eAu1 + eDu1);
	bv[n2+ni[0]-1] = bv[n2+ni[0]-1] + eMu2 * dti  -  0.5 * (eAu2 + eDu2);
	bv[n3+ni[0]-1] = bv[n3+ni[0]-1] + eMu3 * dti  -  0.5 * (eAu3 + eDu3);
	bv[n1+ni[1]-1] = bv[n1+ni[1]-1] + eMv1 * dti  -  0.5 * (eAv1 + eDv1);
	bv[n2+ni[1]-1] = bv[n2+ni[1]-1] + eMv2 * dti  -  0.5 * (eAv2 + eDv2);
	bv[n3+ni[1]-1] = bv[n3+ni[1]-1] + eMv3 * dti  -  0.5 * (eAv3 + eDv3);
	
// ---------- Stabilized term ----------
    ts = tau[m];
    tp = tau[m];
    
// Ms Term
    tumu  = ts * (emua1 * u1 + emua2 * u2 + emua3 * u3);
    tvmu  = ts * (emva1 * u1 + emva2 * u2 + emva3 * u3);
    tumv  = ts * (emua1 * v1 + emua2 * v2 + emua3 * v3);
    tvmv  = ts * (emva1 * v1 + emva2 * v2 + emva3 * v3);
    eMsu1 = b1 * tumu + c1 * tvmu;
    eMsu2 = b2 * tumu + c2 * tvmu;
    eMsu3 = b3 * tumu + c3 * tvmu;
    eMsv1 = b1 * tumv + c1 * tvmv;
    eMsv2 = b2 * tumv + c2 * tvmv;
    eMsv3 = b3 * tumv + c3 * tvmv;
    
//  ! Mp Term
    tu   = tp * (u1 + u2 + u3) * a03;
    tv   = tp * (v1 + v2 + v3) * a03;
    eMp1 = b1 * tu + c1 * tv;
    eMp2 = b2 * tu + c2 * tv;
    eMp3 = b3 * tu + c3 * tv;
    
//! As Term
    tumu  = ts * (ua1 * emua1 + ua2 * emua2 + ua3 * emua3);
    tumv  = ts * (ua1 * emva1 + ua2 * emva2 + ua3 * emva3);
    tvmv  = ts * (va1 * emva1 + va2 * emva2 + va3 * emva3);
    stxu  = tumu * dxu + tumv * dyu;
    styu  = tumv * dxu + tvmv * dyu;
    stxv  = tumu * dxv + tumv * dyv;
    styv  = tumv * dxv + tvmv * dyv;
    eAsu1 = b1 * stxu + c1 * styu;
    eAsu2 = b2 * stxu + c2 * styu;
    eAsu3 = b3 * stxu + c3 * styu;
    eAsv1 = b1 * stxv + c1 * styv;
    eAsv2 = b2 * stxv + c2 * styv;
    eAsv3 = b3 * stxv + c3 * styv;
    
//! Ap Term
    tu   = tp * (ua1 + ua2 + ua3) * a03;
    tv   = tp * (va1 + va2 + va3) * a03;
    atu  = tu * dxu + tv * dyu;
    atv  = tu * dxv + tv * dyv;
    eAp1 = b1 * atu + c1 * atv;
    eAp2 = b2 * atu + c2 * atv;
    eAp3 = b3 * atu + c3 * atv;
    
    bv[n1+ni[0]-1] = bv[n1+ni[0]-1] + eMsu1 * dti  -  0.5 * eAsu1;
    bv[n2+ni[0]-1] = bv[n2+ni[0]-1] + eMsu2 * dti  -  0.5 * eAsu2;
    bv[n3+ni[0]-1] = bv[n3+ni[0]-1] + eMsu3 * dti  -  0.5 * eAsu3;
    bv[n1+ni[1]-1] = bv[n1+ni[1]-1] + eMsv1 * dti  -  0.5 * eAsv1;
    bv[n2+ni[1]-1] = bv[n2+ni[1]-1] + eMsv2 * dti  -  0.5 * eAsv2;
    bv[n3+ni[1]-1] = bv[n3+ni[1]-1] + eMsv3 * dti  -  0.5 * eAsv3;
    bv[n1+ni[2]-1] = bv[n1+ni[2]-1] + eMp1  * dti  -  0.5 * eAp1;
    bv[n2+ni[2]-1] = bv[n2+ni[2]-1] + eMp2  * dti  -  0.5 * eAp2;
    bv[n3+ni[2]-1] = bv[n3+ni[2]-1] + eMp3  * dti  -  0.5 * eAp3;
    }
    
}
//////////////////////////////////////////////////////////////
///////dscale
///////////////////////////////////////////////////////////
void dscale(){
    int m, i, j, nn[9];
    
    for(i=0;i<node*3;i++){
	diag[i] = 1.0 / sqrt(fabs(diag[i]));
    }
    
    for(m=0;m<nelm;m++){
	for(i=0;i<3;i++){
	    for(j=0;j<3;j++){
		nn[3*i+j] = nc[j][m]+ni[i];//????
	    }
	}
	for(i=0;i<9;i++){
	    for(j=0;j<9;j++){
		ea[i][j][m] = ea[i][j][m] * diag[nn[i]-1] * diag[nn[j]-1];
	    }
	}
    }    
}


//////////////////////////////////////////////////////////////
///////GPBiCG
///////////////////////////////////////////////////////////
void GPBiCG(double A[][9][nelm],double x[], double b[], double d[], int ibc[],
	    double r[], double r0[], double p[], double t[], double y[], 
	    double u[], double z[], double w[], double Ap[], double At[], 
	    int k )
{
    int i;
    double  r_r, r0_r, r0_r0, y_y, At_t, At_At, y_t, y_At;
    double  alph, beta, zeta, eta, pk, eps;
    double DOTnakaji;
    
    eps=0.00001;
    
    for(i=0;i<node*3;i++){
	x[i] = x[i] / d[i];
	r[i] = b[i] * d[i];
    }
    
    bound0(r,ibc);
    matvec(A, x, Ap,ibc);
    
    for(i=0;i<node*3;i++) r[i] = r[i] - Ap[i];
    for(i=0;i<node*3;i++) r0[i]= r[i];
    
    r0_r=0.0;    
    for(i=0;i<node*3;i++){
	r0_r += r0[i]*r[i];
    }
    
    for(i=0;i<node*3;i++){
	p[i]  = 0.0;
	u[i]  = 0.0;
	t[i]  = 0.0;
	w[i]  = 0.0;
	z[i]  = 0.0;
    }
    beta  = 0.0;
    pk = 0.0;
    
//===============================================================
    k = 0;
    if(sqrt(r0_r)>eps){
	for(k=0;k<node*3;k++){
	    
	    for(i=0;i<node*3;i++) p[i]= r[i]+ beta*(p[i]-u[i]);
	    matvec(A, p, Ap,ibc);
	    
	    DOTnakaji=0.0;
	    for(i=0;i<node*3;i++){DOTnakaji += r0[i]*Ap[i];}	
	    alph = r0_r / DOTnakaji;
	    
	    for(i=0;i<node*3;i++) y[i]=t[i] -r[i] -alph*w[i] +alph*Ap[i];
	    for(i=0;i<node*3;i++) u[i]=t[i] -r[i] +beta*u[i];
	    for(i=0;i<node*3;i++) t[i]=r[i] -alph*Ap[i];
	    
	    matvec(A, t, At,ibc);
	 
	    y_y=0.0; At_t=0.0; At_At=0.0; y_t=0.0;  y_At=0.0;
	    for(i=0;i<node*3;i++) y_y   += y[i]*y[i];
	    for(i=0;i<node*3;i++) At_t  += At[i]*t[i];
	    for(i=0;i<node*3;i++) At_At += At[i]*At[i];
	    for(i=0;i<node*3;i++) y_t   += y[i]*t[i];
	    for(i=0;i<node*3;i++) y_At  += y[i]*At[i];
	    
	    zeta=(y_y*At_t -y_t*y_At*pk)/(At_At*y_y -y_At*y_At*pk);
	    eta =(At_At*y_t -y_At*At_t)/(At_At*y_y -y_At*y_At)*pk;
	    pk = 1.0;
	    for(i=0;i<node*3;i++) u[i]= zeta*Ap[i] +eta*u[i];
	    for(i=0;i<node*3;i++) z[i]= zeta*r[i] +eta*z[i] -alph*u[i];
	    for(i=0;i<node*3;i++) x[i]= x[i] +alph*p[i] +z[i];
	    for(i=0;i<node*3;i++) r[i]= t[i] -eta*y[i] - zeta*At[i];
	    r_r=0.0;
	    for(i=0;i<node*3;i++) r_r += r[i]*r[i];
	 
//!CHECK write(6,*) k, dsqrt(r_r)
	    if(sqrt(r_r)<=eps) break;     // ! Convergence Check!
	    r0_r0 = r0_r;

	    r0_r=0.0;
	    for(i=0;i<node*3;i++) r0_r += r0[i]*r[i];
	    beta = alph / zeta * r0_r / r0_r0;
	    for(i=0;i<node*3;i++) w[i] = At[i] + beta * Ap[i];
	}
	if(k==node*3 +1){ 
	    printf("Not Convergence (GPBi-CG)");
	    exit(1);
	}
    }
//================================================================
    for(i=0;i<node*3;i++){
	x[i] = x[i] * d[i];
    }
}


//////////////////////////////////////////////////////////////////
//matvec
//////////////////////////////////////////////////////////////
void matvec(double A[][9][nelm],double x[],double r[], int ibc[])
{    
    int m, i, j, nn[9];
    
    for(i=0;i<node*3;i++) r[i] = 0.0;
    
    for(m=0;m<nelm;m++){
	for(i=0;i<3;i++){
	    for(j=0;j<3;j++){
		nn[i*3+j] = nc[j][m]+ni[i];
	    }
	}
	for(i=0;i<9;i++){
	    for(j=0;j<9;j++){
		r[nn[i]-1] = r[nn[i]-1] + A[i][j][m] * x[nn[j]-1];
	    }
	}
    }
    bound0(r, ibc);   
}


///Passive ///////////////////////////////////////////////////////////////////////
///Passive ///////////////////////////////////////////////////////////////////////
///Passive ///////////////////////////////////////////////////////////////////////
///Scalar  ///////////////////////////////////////////////////////////////////////

void cstepch(){
    int i,n;
    for(i=0;i<cc;i++){
	for(n=0;n<node;n++){	
	    ccua[i][n] = 1.5 * cuvp[n] - 0.5*ccu[i][n];
	    ccu[i][n] = cuvp[n];
	}
    }
}

void cbound0(double cuvp[], int ciubc[]){
    int i,ib;
    for(i=0;i<cc;i++){
	for(ib=0;ib<ciubc[i];ib++){
	    cuvp[cnubc[i][ib]-1]=0.0;
	}
    }
}

////////////////////////////////////////////////////////////////
////cmakLHS
///////////////////////////////////////////////////////////////
void cmakLHS(double dti, double rei, double ea[][3][nelm], double diag[], double Sci){
    int i;
    int  m, n1, n2, n3;
    double a01, a03, b1, b2, b3, c1, c2, c3,              
	ts,      tp,        
	emd,     emu,     emu1,    emu2,    emu3,    
	emv1,    emv2,    emv3,            
	eMs_11,  eMs_12,  eMs_13,  eMs_21,  eMs_22,
	eMs_23,  eMs_31,  eMs_32,  eMs_33, 
	eA_11,   eA_12,   eA_13,   eA_21,   eA_22,   eA_23,   
	eA_31,   eA_32,   eA_33,  
	easu1,   easu2,   easu3,   easv1,   easv2,   easv3,	
	eAs_11,  eAs_12,  eAs_13,  eAs_21,  eAs_22,  eAs_23,  
	eAs_31,  eAs_32,  eAs_33;
    double phi[3];
    double ua1, ua2, ua3, va1, va2, va3;
    double u1, u2, u3, v1, v2, v3;
    
    for(i=0;i<node*cc;i++){
	cdiag[i] = 0.0;
    }
    
    for(m=0;m<nelm;m++){
	n1 = nc[0][m];
	n2 = nc[1][m];
	n3 = nc[2][m];
	a01 = area[m];
	a03 = area[m] / 3.0;
	tp = tau[m];
	b1 = bc[0][0][m];
	b2 = bc[0][1][m];
	b3 = bc[0][2][m];
	c1 = bc[1][0][m];
	c2 = bc[1][1][m];
	c3 = bc[1][2][m];
	
	ua1 = ua[0][n1-1];
	ua2 = ua[0][n2-1];
	ua3 = ua[0][n3-1];
	va1 = ua[1][n1-1];
	va2 = ua[1][n2-1];
	va3 = ua[1][n3-1];
	
	u1 = uu[0][n1-1];
	u2 = uu[0][n2-1];
	u3 = uu[0][n3-1];
	v1 = uu[1][n1-1];
	v2 = uu[1][n2-1];
	v3 = uu[1][n3-1];

	phi[0] = ccu[0][n1-1];
	phi[1] = ccu[0][n2-1];
	phi[2] = ccu[0][n3-1];
	 
// ---- M Matrix ----------
         emd = a03 * 0.5;
         emu = a03 * 0.25;
	 
// ---- A Matrix ----------
         emu1 = emd * ua1 + emu * ua2 + emu * ua3;
         emu2 = emu * ua1 + emd * ua2 + emu * ua3;
         emu3 = emu * ua1 + emu * ua2 + emd * ua3;
         emv1 = emd * va1 + emu * va2 + emu * va3;
         emv2 = emu * va1 + emd * va2 + emu * va3;
         emv3 = emu * va1 + emu * va2 + emd * va3;

         eA_11 = emu1 * b1 + emv1 * c1;
         eA_12 = emu1 * b2 + emv1 * c2;
         eA_13 = emu1 * b3 + emv1 * c3;
         eA_21 = emu2 * b1 + emv2 * c1;
         eA_22 = emu2 * b2 + emv2 * c2;
         eA_23 = emu2 * b3 + emv2 * c3;
         eA_31 = emu3 * b1 + emv3 * c1;
         eA_32 = emu3 * b2 + emv3 * c2;
         eA_33 = emu3 * b3 + emv3 * c3;

// ---- Ms Matrix ----------

         eMs_11 = tp * ( b1 * emu1 + c1 * emv1);
         eMs_12 = tp * ( b1 * emu2 + c1 * emv2);
         eMs_13 = tp * ( b1 * emu3 + c1 * emv3);
         eMs_21 = tp * ( b2 * emu1 + c2 * emv1);
         eMs_22 = tp * ( b2 * emu2 + c2 * emv2);
         eMs_23 = tp * ( b2 * emu3 + c2 * emv3);
         eMs_31 = tp * ( b3 * emu1 + c3 * emv1);
         eMs_32 = tp * ( b3 * emu2 + c3 * emv2);
         eMs_33 = tp * ( b3 * emu3 + c3 * emv3);
	 
// ---- As Matrix ----------
	 easu1 = eMs_11 * ua1 + eMs_12 * ua2 + eMs_13 * ua3;
	 easu2 = eMs_21 * ua1 + eMs_22 * ua2 + eMs_23 * ua3;
	 easu3 = eMs_31 * ua1 + eMs_32 * ua2 + eMs_33 * ua3;
	 easv1 = eMs_11 * va1 + eMs_12 * va2 + eMs_13 * va3;
	 easv2 = eMs_21 * va1 + eMs_22 * va2 + eMs_23 * va3;
	 easv3 = eMs_31 * va1 + eMs_32 * va2 + eMs_33 * va3;

         eAs_11 = easu1 * b1 + easv1 * c1;
         eAs_12 = easu1 * b2 + easv1 * c2;
         eAs_13 = easu1 * b3 + easv1 * c3;
         eAs_21 = easu2 * b1 + easv2 * c1;
         eAs_22 = easu2 * b2 + easv2 * c2;
         eAs_23 = easu2 * b3 + easv2 * c3;
         eAs_31 = easu3 * b1 + easv3 * c1;
         eAs_32 = easu3 * b2 + easv3 * c2;
         eAs_33 = easu3 * b3 + easv3 * c3;
	 
// ---- D Matrix ----------

	 double eD11, eD12, eD13, eD21, eD22, eD23, eD31, eD32, eD33;

         eD11 = a01 * rei * Sci * (b1 * b1 + c1 * c1 );
         eD12 = a01 * rei * Sci * (b1 * b2 + c1 * c2 );
         eD13 = a01 * rei * Sci * (b1 * b3 + c1 * c3 );

         eD21 = a01 * rei * Sci * (b2 * b1 + c2 * c1 );
         eD22 = a01 * rei * Sci * (b2 * b2 + c2 * c2 );
         eD23 = a01 * rei * Sci * (b2 * b3 + c2 * c3 );

         eD31 = a01 * rei * Sci * (b3 * b1 + c3 * c1 );
         eD32 = a01 * rei * Sci * (b3 * b2 + c3 * c2 );
         eD33 = a01 * rei * Sci * (b3 * b3 + c3 * c3 );

	 
// ---------- Element by Element ( 9 x 9 ) ----------
//  Momentum X A(1-3,1-9)
	 
	 cea[0][0][m] = dti * (emd + eMs_11)  +  0.5 * (eA_11 + eAs_11 + eD11);
	 cea[0][1][m] = dti * (emu + eMs_12)  +  0.5 * (eA_12 + eAs_12 + eD12);
	 cea[0][2][m] = dti * (emu + eMs_13)  +  0.5 * (eA_13 + eAs_13 + eD13);
	 cea[1][0][m] = dti * (emu + eMs_21)  +  0.5 * (eA_21 + eAs_21 + eD21);
	 cea[1][1][m] = dti * (emd + eMs_22)  +  0.5 * (eA_22 + eAs_22 + eD22);
	 cea[1][2][m] = dti * (emu + eMs_23)  +  0.5 * (eA_23 + eAs_23 + eD23);
	 cea[2][0][m] = dti * (emu + eMs_31)  +  0.5 * (eA_31 + eAs_31 + eD31);
	 cea[2][1][m] = dti * (emu + eMs_32)  +  0.5 * (eA_32 + eAs_32 + eD32);
	 cea[2][2][m] = dti * (emd + eMs_33)  +  0.5 * (eA_33 + eAs_33 + eD33);


/*	 
	 cea[0][0][m] = dti * (emd )  +  0.5 * (eA_11 + eD11);
	 cea[0][1][m] = dti * (emu )  +  0.5 * (eA_12 + eD12);
	 cea[0][2][m] = dti * (emu )  +  0.5 * (eA_13 + eD13);
	 cea[1][0][m] = dti * (emu )  +  0.5 * (eA_21 + eD21);
	 cea[1][1][m] = dti * (emd )  +  0.5 * (eA_22 + eD22);
	 cea[1][2][m] = dti * (emu )  +  0.5 * (eA_23 + eD23);
	 cea[2][0][m] = dti * (emu )  +  0.5 * (eA_31 + eD31);
	 cea[2][1][m] = dti * (emu )  +  0.5 * (eA_32 + eD32);
	 cea[2][2][m] = dti * (emd )  +  0.5 * (eA_33 + eD33);
*/
	 
//! ---------- for Scaling ----------
	 cdiag[n1-1] = cdiag[n1-1] + cea[0][0][m];
	 cdiag[n2-1] = cdiag[n2-1] + cea[1][1][m];
	 cdiag[n3-1] = cdiag[n3-1] + cea[2][2][m];
    }

  
//! Diagonal Scaling      
    cdscale ();
}
////////////////////////////////////////////////////////
//////////  end of cmakLHS
////////////////////////////////////////////////////////


/////////////////////////////////////////////////////
//////cmakRHS
////////////////////////////////////////////////////
void cmakRHS(double dti, double rei, double ccu[][node], double cbv[], double Sci){
    int i;
    int  m, n1, n2, n3;
    double a01, a03, b1, b2, b3, c1, c2, c3,              
	ts,      tp,        
	emd,     emu,     emu1,    emu2,    emu3,    
	emv1,    emv2,    emv3,            
	eMs_11,  eMs_12,  eMs_13,  eMs_21,  eMs_22,
	eMs_23,  eMs_31,  eMs_32,  eMs_33, 
	eA_11,   eA_12,   eA_13,   eA_21,   eA_22,   eA_23,   
	eA_31,   eA_32,   eA_33,  
	easu1,   easu2,   easu3,   easv1,   easv2,   easv3,	
	eAs_11,  eAs_12,  eAs_13,  eAs_21,  eAs_22,  eAs_23,  
	eAs_31,  eAs_32,  eAs_33;
    double phi[3];
    double ua1, ua2, ua3, va1, va2, va3;
    double u1, u2, u3, v1, v2, v3;
        
    for(i=0;i<node*cc;i++){
	cbv[i] = 0.0;
    }
    
    for(m=0;m<nelm;m++){
//////////////////////////
///////////////////////// COPY OF LHS
	n1 = nc[0][m];
	n2 = nc[1][m];
	n3 = nc[2][m];
	a01 = area[m];
	a03 = area[m] / 3.0;
	tp = tau[m];
	b1 = bc[0][0][m];
	b2 = bc[0][1][m];
	b3 = bc[0][2][m];
	c1 = bc[1][0][m];
	c2 = bc[1][1][m];
	c3 = bc[1][2][m];
	
	ua1 = ua[0][n1-1];
	ua2 = ua[0][n2-1];
	ua3 = ua[0][n3-1];
	va1 = ua[1][n1-1];
	va2 = ua[1][n2-1];
	va3 = ua[1][n3-1];
	
	u1 = uu[0][n1-1];
	u2 = uu[0][n2-1];
	u3 = uu[0][n3-1];
	v1 = uu[1][n1-1];
	v2 = uu[1][n2-1];
	v3 = uu[1][n3-1];

	phi[0] = ccu[0][n1-1];
	phi[1] = ccu[0][n2-1];
	phi[2] = ccu[0][n3-1];
	 
// ---- M Matrix ----------
         emd = a03 * 0.5;
         emu = a03 * 0.25;
	 
// ---- A Matrix ----------
         emu1 = emd * ua1 + emu * ua2 + emu * ua3;
         emu2 = emu * ua1 + emd * ua2 + emu * ua3;
         emu3 = emu * ua1 + emu * ua2 + emd * ua3;
         emv1 = emd * va1 + emu * va2 + emu * va3;
         emv2 = emu * va1 + emd * va2 + emu * va3;
         emv3 = emu * va1 + emu * va2 + emd * va3;

         eA_11 = emu1 * b1 + emv1 * c1;
         eA_12 = emu1 * b2 + emv1 * c2;
         eA_13 = emu1 * b3 + emv1 * c3;
         eA_21 = emu2 * b1 + emv2 * c1;
         eA_22 = emu2 * b2 + emv2 * c2;
         eA_23 = emu2 * b3 + emv2 * c3;
         eA_31 = emu3 * b1 + emv3 * c1;
         eA_32 = emu3 * b2 + emv3 * c2;
         eA_33 = emu3 * b3 + emv3 * c3;

// ---- Ms Matrix ----------

         eMs_11 = tp * ( b1 * emu1 + c1 * emv1);
         eMs_12 = tp * ( b1 * emu2 + c1 * emv2);
         eMs_13 = tp * ( b1 * emu3 + c1 * emv3);
         eMs_21 = tp * ( b2 * emu1 + c2 * emv1);
         eMs_22 = tp * ( b2 * emu2 + c2 * emv2);
         eMs_23 = tp * ( b2 * emu3 + c2 * emv3);
         eMs_31 = tp * ( b3 * emu1 + c3 * emv1);
         eMs_32 = tp * ( b3 * emu2 + c3 * emv2);
         eMs_33 = tp * ( b3 * emu3 + c3 * emv3);
	 
// ---- As Matrix ----------
	 easu1 = eMs_11 * ua1 + eMs_12 * ua2 + eMs_13 * ua3;
	 easu2 = eMs_21 * ua1 + eMs_22 * ua2 + eMs_23 * ua3;
	 easu3 = eMs_31 * ua1 + eMs_32 * ua2 + eMs_33 * ua3;
	 easv1 = eMs_11 * va1 + eMs_12 * va2 + eMs_13 * va3;
	 easv2 = eMs_21 * va1 + eMs_22 * va2 + eMs_23 * va3;
	 easv3 = eMs_31 * va1 + eMs_32 * va2 + eMs_33 * va3;

         eAs_11 = easu1 * b1 + easv1 * c1;
         eAs_12 = easu1 * b2 + easv1 * c2;
         eAs_13 = easu1 * b3 + easv1 * c3;
         eAs_21 = easu2 * b1 + easv2 * c1;
         eAs_22 = easu2 * b2 + easv2 * c2;
         eAs_23 = easu2 * b3 + easv2 * c3;
         eAs_31 = easu3 * b1 + easv3 * c1;
         eAs_32 = easu3 * b2 + easv3 * c2;
         eAs_33 = easu3 * b3 + easv3 * c3;

// ---- D Matrix ----------

	 double eD11, eD12, eD13, eD21, eD22, eD23, eD31, eD32, eD33;

         eD11 = a01 * rei * Sci * (b1 * b1 + c1 * c1);
         eD12 = a01 * rei * Sci * (b1 * b2 + c1 * c2);
         eD13 = a01 * rei * Sci * (b1 * b3 + c1 * c3);

         eD21 = a01 * rei * Sci * (b2 * b1 + c2 * c1);
         eD22 = a01 * rei * Sci * (b2 * b2 + c2 * c2);
         eD23 = a01 * rei * Sci * (b2 * b3 + c2 * c3);

         eD31 = a01 * rei * Sci * (b3 * b1 + c3 * c1);
         eD32 = a01 * rei * Sci * (b3 * b2 + c3 * c2);
         eD33 = a01 * rei * Sci * (b3 * b3 + c3 * c3);

///////////////////////// END COPY OF LHS
///////////////////////////////////////////////////////////////////////////

// M Term
	 double eMu1 , eMu2, eMu3;
	 eMu1 = emd * phi[0] + emu * phi[1] + emu * phi[2];
	 eMu2 = emu * phi[0] + emd * phi[1] + emu * phi[2];
	 eMu3 = emu * phi[0] + emu * phi[1] + emd * phi[2];

	 double eMsu1, eMsu2, eMsu3;
	 eMsu1 = eMs_11 * phi[0] + eMs_12 * phi[1] + eMs_13 * phi[2];
	 eMsu2 = eMs_21 * phi[0] + eMs_22 * phi[1] + eMs_23 * phi[2];
	 eMsu3 = eMs_31 * phi[0] + eMs_32 * phi[1] + eMs_33 * phi[2];

	 double eAu1 , eAu2, eAu3;
	 eAu1 = eA_11 * phi[0] + eA_12 * phi[1] + eA_13 * phi[2];
	 eAu2 = eA_21 * phi[0] + eA_22 * phi[1] + eA_23 * phi[2];
	 eAu3 = eA_31 * phi[0] + eA_32 * phi[1] + eA_33 * phi[2];
	 
	 double eAsu1, eAsu2, eAsu3;
	 eAsu1 = eAs_11 * phi[0] + eAs_12 * phi[1] + eAs_13 * phi[2];
	 eAsu2 = eAs_21 * phi[0] + eAs_22 * phi[1] + eAs_23 * phi[2];
	 eAsu3 = eAs_31 * phi[0] + eAs_32 * phi[1] + eAs_33 * phi[2];
	 
	 double eDu1 , eDu2, eDu3;
	 eDu1 = eD11 * phi[0] + eD12 * phi[1] + eD13 * phi[2];
	 eDu2 = eD21 * phi[0] + eD22 * phi[1] + eD23 * phi[2];
	 eDu3 = eD31 * phi[0] + eD32 * phi[1] + eD33 * phi[2];

	 cbv[n1-1] = cbv[n1-1] +(eMu1 + eMsu1) * dti - 0.5 * ( eAu1 + eAsu1 + eDu1 );
	 cbv[n2-1] = cbv[n2-1] +(eMu2 + eMsu2) * dti - 0.5 * ( eAu2 + eAsu2 + eDu2 );
	 cbv[n3-1] = cbv[n3-1] +(eMu3 + eMsu3) * dti - 0.5 * ( eAu3 + eAsu3 + eDu3 );	
//	 cbv[n1-1] = cbv[n1-1] +(eMu1 ) * dti - 0.5 * ( eAu1 + eDu1 );
//	 cbv[n2-1] = cbv[n2-1] +(eMu2 ) * dti - 0.5 * ( eAu2 + eDu2 );
//	 cbv[n3-1] = cbv[n3-1] +(eMu3 ) * dti - 0.5 * ( eAu3 + eDu3 );	

    }
}
////////////////////////////////////////////////////////
//////////  END of cmakRHS
////////////////////////////////////////////////////////

void cdscale(){
    int m, i, j, nn[3];

    
    for(i=0;i<node*cc;i++){
	cdiag[i] = 1.0 / sqrt(fabs(cdiag[i]));
    }
    
    for(m=0;m<nelm;m++){
	for(i=0;i<cc;i++){
	    for(j=0;j<3;j++){
		nn[3*i+j] = nc[j][m];//????
	    }
	}
	for(i=0;i<3;i++){
	    for(j=0;j<3;j++){
		cea[i][j][m] = cea[i][j][m] * cdiag[nn[i]-1] * cdiag[nn[j]-1];
	    }
	}
    }
}


//////////////////////////////////////////////////////////////
///////cGPBiCG
///////////////////////////////////////////////////////////
void cGPBiCG(double A[][3][nelm],double x[], double b[], double d[], int ibc[],
	     double r[], double r0[], double p[], double t[], double y[], 
	     double u[], double z[], double w[], double Ap[], double At[], 
	     int k )
{
    int i;
    double  r_r, r0_r, r0_r0, y_y, At_t, At_At, y_t, y_At;
    double  alph, beta, zeta, eta, pk, eps;
    double DOTnakaji;
    
    eps=0.00001;
    
    for(i=0;i<node*cc;i++){
	x[i] = x[i] / d[i];
	r[i] = b[i] * d[i];
    }
    
    cbound0(r,ibc);
    cmatvec(A, x, Ap,ibc);
    
    for(i=0;i<node*cc;i++) r[i] = r[i] - Ap[i];
    for(i=0;i<node*cc;i++) r0[i]= r[i];
    
    r0_r=0.0;    
    for(i=0;i<node*cc;i++){
	r0_r += r0[i]*r[i];
    }
    
    for(i=0;i<node*cc;i++){
	p[i]  = 0.0;
	u[i]  = 0.0;
	t[i]  = 0.0;
	w[i]  = 0.0;
	z[i]  = 0.0;
    }
    beta  = 0.0;
    pk = 0.0;
    
//===============================================================
    k = 0;
    if(sqrt(r0_r)>eps){
	for(k=0;k<node*cc;k++){
	    
	    for(i=0;i<node*cc;i++) p[i]= r[i]+ beta*(p[i]-u[i]);
	    cmatvec(A, p, Ap,ibc);
	    
	    DOTnakaji=0.0;
	    for(i=0;i<node*cc;i++){DOTnakaji += r0[i]*Ap[i];}	
	    alph = r0_r / DOTnakaji;
	    
	    for(i=0;i<node*cc;i++) y[i]=t[i] -r[i] -alph*w[i] +alph*Ap[i];
	    for(i=0;i<node*cc;i++) u[i]=t[i] -r[i] +beta*u[i];
	    for(i=0;i<node*cc;i++) t[i]=r[i] -alph*Ap[i];
	    
	    cmatvec(A, t, At,ibc);
	    
	    y_y=0.0; At_t=0.0; At_At=0.0; y_t=0.0;  y_At=0.0;
	    for(i=0;i<node*cc;i++) y_y   += y[i]*y[i];
	    for(i=0;i<node*cc;i++) At_t  += At[i]*t[i];
	    for(i=0;i<node*cc;i++) At_At += At[i]*At[i];
	    for(i=0;i<node*cc;i++) y_t   += y[i]*t[i];
	    for(i=0;i<node*cc;i++) y_At  += y[i]*At[i];
	    
	    zeta=(y_y*At_t -y_t*y_At*pk)/(At_At*y_y -y_At*y_At*pk);
	    eta =(At_At*y_t -y_At*At_t)/(At_At*y_y -y_At*y_At)*pk;
	    pk = 1.0;
	    for(i=0;i<node*cc;i++) u[i]= zeta*Ap[i] +eta*u[i];
	    for(i=0;i<node*cc;i++) z[i]= zeta*r[i] +eta*z[i] -alph*u[i];
	    for(i=0;i<node*cc;i++) x[i]= x[i] +alph*p[i] +z[i];
	    for(i=0;i<node*cc;i++) r[i]= t[i] -eta*y[i] - zeta*At[i];
	    r_r=0.0;
	    for(i=0;i<node*cc;i++) r_r += r[i]*r[i];
	    
//!CHECK write(6,*) k, dsqrt(r_r)
	    if(sqrt(r_r)<=eps) break;     // ! Convergence Check!
	    r0_r0 = r0_r;
	    
	    r0_r=0.0;
	    for(i=0;i<node*cc;i++) r0_r += r0[i]*r[i];
	    beta = alph / zeta * r0_r / r0_r0;
	    for(i=0;i<node*cc;i++) w[i] = At[i] + beta * Ap[i];
	}
	if(k==node*cc +1){ 
	    printf("Not Convergence (GPBi-CG)");
	    exit(1);
	}
    }
//================================================================
    for(i=0;i<node*cc;i++){
	x[i] = x[i] * d[i];
    }
}


//////////////////////////////////////////////////////////////////
//cmatvec
//////////////////////////////////////////////////////////////
void cmatvec(double A[][3][nelm],double x[],double r[], int ibc[])
{    
    int m, i, j, nn[3];
    
    for(i=0;i<node*cc;i++) r[i] = 0.0;
    
    for(m=0;m<nelm;m++){
	for(i=0;i<cc;i++){
	    for(j=0;j<3;j++){
		nn[i*3+j] = nc[j][m];
	    }
	}
	for(i=0;i<3;i++){
	    for(j=0;j<3;j++){
		r[nn[i]-1] = r[nn[i]-1] + A[i][j][m] * x[nn[j]-1];
	    }
	}
    }
    cbound0(r, ibc);   
}


void cmaktau(double dti, double rei, double Sci){
    int m, n1, n2, n3;
    double a01, b1, b2, b3, c1, c2, c3, u, v, uv, d, t1, t2, t3;
    
    t1 = 4.0 * dti * dti;
    
    for(m=0;m<nelm;m++){
	n1 = nc[0][m];
	n2 = nc[1][m];
	n3 = nc[2][m];
	a01 = area[m];
	b1 = bc[0][0][m];
	b2 = bc[0][1][m];
	b3 = bc[0][2][m];
	c1 = bc[1][0][m];
	c2 = bc[1][1][m];
	c3 = bc[1][2][m];
	u = ( ua[0][n1-1] + ua[0][n2-1] + ua[0][n3-1] ) / 3.0;
	v = ( ua[1][n1-1] + ua[1][n2-1] + ua[1][n3-1] ) / 3.0;
	uv = u * u + v * v;
	d = fabs( u * b1 + v * c1 )  + fabs( u * b2 + v * c2 ) 
	    + fabs( u * b3 + v * c3 );
	
	t2 = d * d;
	if(uv<0.0000000001){
	    t3 = (2.0 * rei * Sci/ a01)*(2.0 * rei * Sci/ a01);
	} else{
	    t3 = (rei * Sci * d * d / uv)*(rei * Sci *d * d / uv);
	}
	tau[m] = 1.0 / sqrt(t1 + t2 + t3);   
    }   
}
